Attribute VB_Name = "DirectDraw"
'Function calls
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long


'Constants
Const LR_LOADFROMFILE = &H10
Const LR_CREATEDIBSECTION = &H2000
Const SRCCOPY = &HCC0020

'Defining the bitmap for the LoadImage API call
Private Type BITMAP
        bmType          As Long
        bmWidth         As Long
        bmHeight        As Long
        bmWidthBytes    As Long
        bmPlanes        As Integer
        bmBitsPixel     As Integer
        bmBits          As Long
End Type

Function LoadBitmapIntoDXS(DXObject As IDirectDraw2, ByVal BMPFile As String) As IDirectDrawSurface2
    
    Dim hBitmap As Long                 ' The handle to the bitmap
    Dim dBitmap As BITMAP
    Dim TempDXD As DDSURFACEDESC
    Dim TempDXS As IDirectDrawSurface2   ' Temporary surface, to render the bitmap.
    Dim dcBitmap As Long
    Dim dcDXS As Long                   ' Handle to the surface
    Dim ddck As DDCOLORKEY              ' Colorkeys
    
    
    'set to black
    ddck.dwColorSpaceLowValue = 0
    ddck.dwColorSpaceHighValue = 0
    
    'Load BMP with LoadImage API
    hBitmap = LoadImage(ByVal 0&, BMPFile, 0, 0, 0, LR_LOADFROMFILE Or LR_CREATEDIBSECTION)
    
    ' BMP Info
    GetObject hBitmap, Len(dBitmap), dBitmap
    
    ' The temporary surface
    With TempDXD
        .dwSize = Len(TempDXD)
        .dwFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
        .DDSCAPS.dwCaps = DDSCAPS_OFFSCREENPLAIN Or DDSCAPS_SYSTEMMEMORY
        .dwWidth = dBitmap.bmWidth
        .dwHeight = dBitmap.bmHeight
    End With
    ' Create Temporary DX surface to render too
    DXObject.CreateSurface TempDXD, TempDXS, Nothing
    
    ' Create DC
    dcBitmap = CreateCompatibleDC(ByVal 0&)
    ' Select BMP into DC
    SelectObject dcBitmap, hBitmap
    
    ' Restore the memory for the temporary surface
    TempDXS.Restore
    ' assign the bitmaps dc to the surface dc
    TempDXS.GetDC dcDXS
    ' Blit BMP from API DC into DX DC using BitBlt
    StretchBlt dcDXS, 0, 0, TempDXD.dwWidth, TempDXD.dwHeight, dcBitmap, 0, 0, dBitmap.bmWidth, dBitmap.bmHeight, Win32.SRCPAINT
    
    
    
    
    'Use the colorkey
    TempDXS.SetColorKey DDCKEY_SRCBLT, ddck
    
    ' Return created DX surface
    Set LoadBitmapIntoDXS = TempDXS
    
    ' Erase temporary stuff
    TempDXS.ReleaseDC dcDXS
    DeleteDC dcBitmap
    DeleteObject hBitmap
    Set TempDXS = Nothing
    
    
End Function



